unit smallhelpers;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, tmex_support, dialogs;
//(Dialogs for the ACCEPTABLE showmessage included below about bad params.

type
  TudrTwoStrings = record
     sPass0,sPass1:string;
     //typically, sPass0 holds a concise version of what's in sPass1.
     end;//definition of type

var udrTwoStrings_Tmp:TudrTwoStrings;

function udrTwoStrings_PrepReportStrings(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):TudrTwoStrings;
function sFixedWidth(bLength:byte;cPad:char;sTmp:string):string;
function sBarGraph(singLo,singHi:single;bLength:byte;singShow:single):string;
function udrTwoStrings_CodedTime(dtTmp:TDateTime):TudrTwoStrings;
//function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;


implementation

//uses ldn032u1;//(To give access to memos on main form<< bad idea! And maybe
//isn't done this way if that's what you want, anyway!)

function sBarGraph(singLo,singHi:single;bLength:byte;singShow:single):string;
//(NOTE TO SELF... MAKE A TUT OF THIS!)

//Will only produse satisfactory results if....
//The two characters used (I used a '*' and a space) take
//   the same horizontal space, ** OR **
//The font of the component where the result is displayed
//   is not proportionally spaced. E.g. Courier is okay.


//(SR is crude at the moment and neither it, nor what's below,
//   guaranteed to do EXACTLY what's promised!... Well... that
//   was my attitude when I started writing this TINY, TRIVIAL
//   routine 90 minutes ago. It OUGHT to work correctly, fully,
//   given the time I've spent on it!!! Argh. 23 Aug 16


//When fully finished, this function will return a string of spaces
//and *'s showing wShow as a bar graph. It will be bLength characters
//singLo will set the lowest value, one that will show all spaces.
//singHi will set the upper value, the one that shows all *s
//Values above or below singLo/ singHi will be clipped to that range.
//So... for bLength=6, singLo=100, singHi=200, here's what you'd see,
//for different values of wShow...

//50: (all spaces)
//100: '       ' (all spaces)
//120: '*      '
//150: '***    '
//190: '****** '
//200: '*******'
//250: '*******'

//-------------------------
//If you want to do something like this, but using only integer-type
//variables, it will work okay as long as you have a LARGE range from
//singLo to singHi, relative to your bLength value. For instance,
//singLo=1500, singHi=3300 and bLength=32 would probably be fine.
//If, say, you were plotting ttures, and you had had the tture in
//degrees C (about 15-33 would be "cool room" to "sensor on tongue"),
//just multiply up the value from Celsius degrees to Celcius centi-
//degrees before passing "the value" (to be graphed) to the graphing
//routine.

var singDiff,singStep,singAcc:single;
  sTmp:string;

begin
if singHi<=singLo then showmessage('Bad params passed to sBarGraph. '+
    'Fix the hard coded error');
if singShow>singHi then singShow:=singHi;
if singShow<singLo then singShow:=singLo;
singDiff:=singHi-singLo;
singStep:=singDiff/bLength;
sTmp:='';
singAcc:=singLo+singStep;
while ((length(sTmp)<bLength)
   and (singShow>singAcc)) do begin

  sTmp:=sTmp+'*';
  singAcc:=singAcc+singStep;
  end;//while

//Now add spaces at the end, in case something else is
//  going on the same line as the bar graph...

while length(sTmp)<=bLength do sTmp:=sTmp+' ';

result:=sTmp;
end;

function sFixedWidth(bLength:byte;cPad:char;sTmp:string):string;
begin
while length(sTmp)<bLength do sTmp:=cPad+sTmp;
result:=sTmp;
end;

function udrTwoStrings_PrepReportStrings(bCallType:byte;siErr:smallint;
      sRoutine,sLoc:string):TudrTwoStrings;
//Prepares two versions of an error message... first is concise, 2nd more verbose
begin
udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);
result.sPass0:=udrTwoStrings_Tmp.sPass0+' In code at:'+sLoc+' saw err '+inttostr(siErr)+
   ' on call '+sRoutine;
result.sPass1:='Err seen on '+udrTwoStrings_Tmp.sPass1+' when '+sRoutine+
   ' called: '+sErrCodeToStr(bCallType,siErr)+
   '. Prgm was at "'+sLoc+'"';
end;

function udrTwoStrings_CodedTime(dtTmp:TDateTime):TudrTwoStrings;
//Typical use...
//   udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);
//   udrTwoStrings_tmp2.sPass0:=udrTwoStrings_Tmp.sPass0+' some stuff, concise;
//   udrTwoStrings_tmp2.sPass1:=udrTwoStrings_Tmp.sPass1+' some stuff, verbose;
//   PostTwoStrings(kP2both,udrTwoStrings_tmp2);
//
//Creates two strings from a date/time
//1) sPass0: The concise string length is constant, the parts always
//occupy the name number of characters. It is
//compact, but not entirely un-readable by a mere
//human... Format is...
//yymddhmm... where...
//yy: year, "16" for "2016"
//m: One character... a= jan, b=feb...
//dd: day... 02 for the second, etc
//h:The hour... 0:a, 1:b... 11am l (ell)
//, noon, m, etc.
//mm: Minutes... 02 for two minutes past hour.
//e.g.: 16b05n09: 2016, Feb, 5th, 13:09.

//e.g.: 16b22b2: 2016, Feb, 22nd, 01:22
//N.B., as illustrated in example of 16b...
//  the "bth" MONTH is Feb, while the "bth" HOUR is 01...
//  (We count months from 1, but hours-since-midnight from zero.)


//(Other string it creates....)
//2) sPass1: A longer, human-friendly string with the date/time

var wYr,wMnth,wDay,wHr,wMin,wSec,wMsec:word;
  sTmpL,sTmpL2:string;

begin
DecodeDate(dtTmp,wYr,wMnth,wDay);
DecodeTime(dtTmp,wHr,wMin,wSec,wMsec);
sTmpL:=copy(inttostr(wYr),3,2);//that's the year taken care of
sTmpL:=sTmpL+chr(96+wMnth);//"a":97  month... finish.
sTmpL2:=inttostr(wDay);
if length(sTmpL2)=1 then sTmpL2:='0'+sTmpL2;
sTmpL:=sTmpL+sTmpL2;//day
sTmpL:=sTmpL+chr(97+wHr);//hour... Yes, 9*7* +wHr
sTmpL2:=inttostr(wMin);
if length(sTmpL2)=1 then sTmpL2:='0'+sTmpL2;
result.sPass0:=sTmpL+sTmpL2+' ';


sTmpL:=inttostr(wDay);
if wMnth=1 then sTmpL2:='Jan';//Start on month part...
if wMnth=2 then sTmpL2:='Feb';
if wMnth=3 then sTmpL2:='Mar';
if wMnth=4 then sTmpL2:='Apr';
if wMnth=5 then sTmpL2:='May';
if wMnth=6 then sTmpL2:='June';
if wMnth=7 then sTmpL2:='July';
if wMnth=8 then sTmpL2:='Sept';
if wMnth=9 then sTmpL2:='Oct';
if wMnth=10 then sTmpL2:='Nov';
if wMnth=11 then sTmpL2:='Dec';
sTmpL:=sTmpL+' '+sTmpL2+' ';//Month
sTmpL:=sTmpL+inttostr(wYr)+', ';
sTmpL2:=inttostr(wHr);
if length(sTmpL2)=1 then sTmpL2:='0'+sTmpL2;
sTmpL:=sTmpL+sTmpL2+':';
sTmpL2:=inttostr(wMin);
if length(sTmpL2)=1 then sTmpL2:='0'+sTmpL2;
sTmpL:=sTmpL+sTmpL2+':';
sTmpL2:=inttostr(wSec);
if length(sTmpL2)=1 then sTmpL2:='0'+sTmpL2;
sTmpL:=sTmpL+sTmpL2;

result.sPass1:=sTmpL;

end;

//NOT USED?
(*function DoReports2(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):TudrTwoStrings;
begin
sTmp:=ReportErr(bCallType,siErr,sRoutine,sLoc);
//Params: group code, error code from TMEX, what routine, where in code.
ldn032f1.meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
end;//DoReports2*)

//NOT USED?
(*function DoReports(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
var sTmp:string;
begin
sTmp:=ReportErr(bCallType,siErr,sRoutine,sLoc);
//Params: group code, error code from TMEX, what routine, where in code.
result:=sTmp;

//////ldn032f1.meMsgsConcise.lines.insert(0,sTmp);//In due course, pass to data log, whatever
end;//DoReports
 *)

{DEPRECATED... not good to be writing to component on higher form...
}
{function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
//bCallType: A TKB allocated code... see sErrCodeToStr
//siErr: The error code returned from a TMEX call
//sRoutine: The name of the routine that returned the error, e.g. TMTouchByte
//   (What this can be restricted by bCallType, but several routines can
//    share one bCallType)
//sLoc: A unique string to ID where the call was in the code, so de-bugging
//   can be done.

//Inserts a verbose string into a memo.
//Returns a concise string which typically would be passed to a log file.
begin
ldn032f1.meMsgs.lines.insert(0,'Err seen at ((time)) when '+sRoutine+
   ' called: '+sErrCodeToStr(bCallType,siErr)+
   '. Prgm was at "'+sLoc+'"');
result:=sCodedTime(now)+' In code at:'+sLoc+' saw err '+inttostr(siErr)+
   ' on call '+sRoutine;
end;//ReportErr
 }

end.
