unit tmex_support;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, iBTMEXPW;
  //Is having to repeat iBTMEXPW here a problem? (Without it, compiler
  //says it hasn't heard of TMTouchByte, etc., so would like to leave.)

const kTmexSupportUnitVers='29 Aug 16**B**';

//See http://sheepdogguides.com/lut/lt4Nb.htm for
//  help with putting things into support units.
type
  TudrTmp_Test = record
     sFrmTest:string;
     bFrmTest:byte;
     end;//definition of type

type
  //Used to return values from a call to a SR
  //which tries to execute both a
  //TMExtendedStartSession and a TMSetup
  TudrTMExtenStrtSessPlusTMSetup = record
     //liSessHdl will EITHER contain the session handle
     //  obtained from TMExtendedSessionStart, OR the
     //  error code from that, or from TMSetup, if the
     //  call of TMExtenedSessionStart went okay.
     liSessHdl:longint;
     //The "message" strings may contain error msgs,
     //warnings, or reports of success
     sMsgConcise,sMsgVerbose:string;
     boSessionValid:boolean;//Not to be confused with
     //global boSessionValid, which will be filled
     //from this.
     end;//definition of type

type
  //Used to return values from a call to a SR
  //which tries to execute TMRom
  TudrTMEXROM = record
     //The "message" strings may contain error msgs,
     //warnings, or reports of success
     sMsgConcise,sMsgVerbose:string;
     boErrSeenL:boolean;//Not to be confused with
     //global boSessionValid, which will be filled
     //from this.
     end;//definition of type

type
  //Used to return values from a call to a SR
  //which tries to read scratchpad, and validate
  //data received with the checksum
  TudrReadScratchpad = record
     b0,b1,b2,b3,b4,b5,b6,b7:byte;//bytes read.
     sWhereErrSeenC,sWhereErrSeenV:string;//e.g. "during TMTouchbyte($BE)"
     //(Command which starts read scratchpad) or
     //"during nth TMTochByte($FF)" (read a byte) or
     //"checksum sent did not match checksum calculated"
     siErrSeen:smallint;//Error seen.
     sErrMsgC,sErrMsgV:string;//TMEX description of error
     boErrSeenL:boolean;//Not to be confused with
     //global variable, which will be filled
     //from this.
     end;//definition of type

type
  //The "0" in the type name is there in case
  //a few different udr types need to be set
  //up to cover different needs.
  TudrTryTmex0 = record
     boFail:boolean;//Returns true if call failed
     siResult:smallint;//Returns error code, if error arose, or
             //byte from MicroLan if it was READIMG, and no
             //error arose. Note: All but LS 8 bits stripped in
             //the "no error" case.
     end;//definition of type

type
  TudrTwoStringsTMS = record//TMS: TmexSupporUnit
     sPass0,sPass1:string;
     //typically, sPass0 holds a concise version of what's in sPass1.
     end;//definition of type


function udrTmp_TestTryUDR:TudrTmp_Test;
function sVerTmex_Support:string;
function TB_TmpTrial:string;
function sErrCodeToStr(bCallType:byte;siErrCode:smallint):string;
function udrTryTMTouchByteRead:TudrTryTmex0;
procedure FillSiaRom(bWhichChip:byte);//Note: Overloaded... see next
procedure FillSiaRom(sTmpL:string);//Note: Overloaded... see prev
//Those two FillSiaRoms my first use of overloading! 28 Aug 16
function udrTryTMExendedStartSessionPlusTMSetup(siPortNumL,
       siAdapterTypeL:smallint):TudrTMExtenStrtSessPlusTMSetup;
  //In record it returns...
  //   liSessHdl:longint;
  //   //The "message" strings may contain error msgs,
  //   //warnings, or reports of success
  //   sMsgConcise,sMsgVerbose:string;
  //   boSessionValid:boolean;//Not to be confused with
  //   //global boSessionValid, which will be filled
  //   //from this.
function bCalcChecksum(b0,b1,b2,b3,b4,b5,b6,b7:byte):byte;
function udrTryTMReadScratchPadAndValidate(liSessH:longint):TudrReadScratchpad;
function udrPassChipIDToBuffer(liSessH:longint;sChipID:string):TudrTMEXROM;

function siInTmexSupp_TMRom(var liSessH:longint):smallint;
function siInTmexSupp_TMStrongAccess(var liSessH:longint):smallint;
function siInTmexSupp_TMAccess(var liSessH:longint):smallint;

//function siInTMEX_FillSiaRom(sChipID:string):smallint;
//function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;

implementation

uses ldn032u1;//This a "back up the line" uses, has to be here, not higher.
//N.B.: **U1* here... the unit, and *F1* below, when specing components of
//         the form IN the unit

var udrTmpTryTmexL:TudrTryTmex0;
    udrTwoStrings_tmp:TudrTwoStringsTMS;
    stabuffForOneWire:array[0..15361]of byte;
    siaROM:array[0..9] of smallint;//An extra element... or two!... provided
        //to preclude the accident of providing too few elements.

//------------------------------------------
function siInTmexSupp_TMRom(var liSessH:longint):smallint;
var siTmpL:smallint;
begin
siTmpL:=TMRom(liSessH,@stabuffForOneWire,@siaROM);
result:=siTmpL;
end;

function siInTmexSupp_TMStrongAccess(var liSessH:longint):smallint;
var siTmpL:smallint;
begin
siTmpL:=TMStrongAccess(liSessH,@stabuffForOneWire);
result:=siTmpL;
end;

function siInTmexSupp_TMAccess(var liSessH:longint):smallint;
var siTmpL:smallint;
begin
siTmpL:=TMAccess(liSessH,@stabuffForOneWire);
result:=siTmpL;
end;




procedure FillSiaRom(sTmpL:string);//Note: Overloaded... see prev
begin
end;

function udrPassChipIDToBuffer(liSessH:longint;sChipID:string):TudrTMEXROM;
//WHAT IT DOES... write up HERE
var siTmpL:smallint;
begin
result.sMsgConcise:='udrPassChipIDToBuffer went Ok';
result.sMsgVerbose:='udrPassChipIDToBuffer executed without '+
   'problems, for chip '+sChipID;
result.boErrSeenL:=false;//but may have to be made true

if length(sChipID)=16 then begin
   FillSiaRom(sChipID);
   end//no ; here
  else begin
     result.sMsgConcise:='qDO-refine: ';
     result.sMsgVerbose:='qDO-refine: ';
     result.boErrSeenL:=true;
     end;

if result.boErrSeenL=false then begin
//siTmpL:=TMRom(liSessH,@stabuffForOneWire,@siaROM);
if siTmpL<0 then begin
   //Documentation does not cover the case of a result
   //  OF zero... only of 1 (all well), and values
   //  of LESS THAN zero. See TMEX API Help doc, for
   //  the meanings of the various possible error values.
   result.sMsgConcise:='qDO-refine: TMRom call returned an error:'+inttostr(siTmpL);
   result.sMsgVerbose:='qDO-refine: TMRom call returned an error:'+inttostr(siTmpL);
   result.boErrSeenL:=true;
   end;
end;
end;//udrPassChipIDToBuffer


function udrTryTMReadScratchPadAndValidate(liSessH:longint):TudrReadScratchpad;
var boErrSeenL:boolean;
    sOutcomeConcise,sOutcomeVerbose:string;
    sitmpL:smallint;
    bChecksumSent:byte;

   procedure WaitBetweenBytes;//SR of udrTryTMReadScratchPadAndValidate
   begin
   //May not be needed. Even calling null routine may be wasting
   //time, introducing a complication we don't need.
   //
   //sleep(2);//too long, and byte lost... but survived 20 in brief tests.
   end;//WaitBetweenBytes, SR of udrTryTMReadScratchPadAndValidate

begin//udrTryTMReadScratchPadAndValidate

result.siErrSeen:=999;//irrelevant, unless an error arises

boErrSeenL:=false;//init
//Next two will be refilled with error messages, if errors arise.
sOutcomeConcise:='udrTryTMReadScratchPadAndValidate went okay';
sOutcomeVerbose:='udrTryTMReadScratchPadAndValidate went okay';

//begin the chip-specific code for the "read what was seen" part...
siTmpL:=TMTouchByte(liSessH,$BE);//Send "Read Scratchpad" command
   //(TMEX name. "Transmit scratchpad" might have been a better name)
if siTmpL=255 then begin
    result.siErrSeen:=siTmpL;
    sOutcomeConcise:='(tweak):TMTouchByte call returned report '+
      'that the MicroLan was shorted at time of $BE command.';
    sOutcomeVerbose:='(tweak):TMTouchByte call returned report '+
      'that the MicroLan was shorted at time of $BE command.';
         boErrSeenL:=true;
         end;
if siTmpL<0 then begin
    result.siErrSeen:=siTmpL;
    sOutcomeConcise:='(tweak):TMTouchByte call returned error '+
      'code '+inttostr(siTmpL)+' at time of $BE command. '+
      'See TMEX Hardware Specific '+
      'Error Return Code for interpretation.';
    sOutcomeVerbose:='(tweak):TMTouchByte call returned error '+
      'code '+inttostr(siTmpL)+' at time of $BE command. '+
      'See TMEX Hardware Specific '+
      'Error Return Code for interpretation.';
         boErrSeenL:=true;
         end;
//Else, siTmp holds a byte returned by the call, but we don't
//have a use for this one, now that we've checked that it
//isn't flagging an error.


//First "try 1st chip specific bit" ends here. No "end" needed.
//(We don't enter this routine, unless all has gone well up to time
//we enter.)

//----------------------------------------------------
//Now read the 9 bytes which will come from the chip
//  due to the "ReadScratchpad" command we issued...

//First byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmex0.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 1st byte, '+
      'location 16827a, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 1st byte of scratchpad (16827b), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b0:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR. (First uise of thie code, 27 Aug 16, was to read a
   //tture value from a DS18B20... but ReadScratchpad, while always retrieving
   //8 bytes, could be retrieving anything. It will depend on the chip, and the
   //call sequence. (In first use, tture was coded across the first two
   //bytes in the Scratchpad.)
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Second byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmex0.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 2nd byte, '+
      'location 16827c, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 2nd byte of scratchpad (16827d), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b1:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Third byte...
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 3rdt byte, '+
      'location 16827e, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 3rd byte of scratchpad (16827f), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b2:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Fourth byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 4th byte, '+
      'location 16827h, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 4th byte of scratchpad (16827i), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b3:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Fifth byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 5th byte, '+
      'location 16827j, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 5th byte of scratchpad (16827k), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b4:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Sixth byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 6th byte, '+
      'location 16827m, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 6th byte of scratchpad (16827n), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b5:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Seventh byte....
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 7th byte, '+
      'location 16827o, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 7th byte of scratchpad (16827p), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b6:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Eighth byte.... lasts DATA byte... checksum byte still to come
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read 8th (last) byte, '+
      'location 16827q, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, 8th (and last, apart from checksum) '+
      'byte of scratchpad (16827r), Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   result.b7:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

//Ninth byte.... the checksum byte, as figured by sending chip still to come
if boErrSeenL=false then begin
udrTmpTryTmexL:=udrTryTMTouchByteRead;

//udrTmpTryTmexL.boFail:=true;//for debug
if udrTmpTryTmexL.boFail then begin
   result.siErrSeen:=udrTmpTryTmexL.siResult;//Pass it up chain of SR calls
   //Space at start of the next two, 'cause they are "stuck on" to date/time stamps
   //   further up the line.
   sOutcomeConcise:=' During TMTouchByte,on attempt to read checksum byte, '+
      'location 16827s, Dallas Error code was '+inttostr(udrTmpTryTmexL.siResult);
   sOutcomeVerbose:=' TMTouchByte failed, fetching checksum byte (16827t), '+
      'Dallas Error code was '+
            inttostr(udrTmpTryTmexL.siResult);
   //Add "translation service" to one or both of above.

   boErrSeenL:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bChecksumSent:=udrTmpTryTmexL.siResult;//Make a note of result... was chopped
   //to 8 bits in SR.
   end;//of else of "if boFail..."}
end;//boErrSeenL=false

WaitBetweenBytes;//see rem at SR decl. It is a SR of the current SR

{
//9th byte.... last...
//And finally, read one more byte, which is a checksum
//calculated from the previous 8.
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822i');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bChecksumSent:=udrTmpTryTmex0.siResult;
   //HMM... is it an 8bit checksum, or 16? IF 16 THREE THINGS NEED FIXING...
   //in udrTmpTryTmex0 siResult should not be stripped down to LS 8 bits,
   //and in read of first two bytes, the value returnen needs to be
   //stripped down to LS 8 bits before being stored in bTtureHi and bTtureLo
   end;//of else of "if boFail..."
end;//boErrSeen=false
}


//Now if bChecksumSent and checksum independently calculated from bytes sent
//match.
if boErrSeenL=false then begin
if bChecksumSent<>bCalcChecksum(result.b7,result.b6,result.b5,result.b4,
   result.b3,result.b2,result.b1,result.b0) then begin
    sOutcomeConcise:=' Code loc16825a: ReadScratchpad checksum failed.';
    sOutcomeVerbose:=' At location 16825a, the Read '+
       'Scratchpad bytes, when subjected to checksum algorithm, returned '+
       'a value that failed to match the checksum sent by the 1-Wire chip.';
    boErrSeenL:=true;
    end//no ; here
  else
    //Nothing
end;//boErrSeen=false


//============

{
//Second byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
//udrTmpTryTmex0.boFail:=true;//FOR DEBUG!!
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822b');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bTtureHi:=udrTmpTryTmex0.siResult;//Make a note of result... was chopped
   //to 8 bits in SR. It contains part of the temperature we're
   //trying to read.
   b1:=bTtureHi;//for chceking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

(*Following "should" work... and does, mostly.

But you can't assume that any time you get an
$FF from TMTouchByte it is an error.

I believe the TMEX API Help info about "$FF is
  an error code" is
  misleading. 23 Aug 16, I lean towards the view
  (and have adapted udrTryTMTouchByteRead) that
  $FF MAY mean that the MicroLan is shorted... but
  ALSO it may simply be that the byte the chip you
  are listening to is SENDING $FF.
*)

//YES.. following could be done "cleverly"... but that might
//obscure the Very Boring stuff that is going on here...

//3rd byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822c');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b2:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//4th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822d');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b3:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//5th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822e');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b4:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//6th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822f');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b5:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//7th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822g');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b6:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//8th byte....
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822h');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   b7:=udrTmpTryTmex0.siResult;//for checking checksum
   end;//of else of "if boFail..."
end;//boErrSeen=false

WaitBriefly(kWaitBetweenTouchByte);

//9th byte.... last...
//And finally, read one more byte, which is a checksum
//calculated from the previous 8.
if boErrSeen=false then begin
udrTmpTryTmex0:=udrTryTMTouchByteRead;
if udrTmpTryTmex0.boFail then begin
udrTwoStrings_tmp:=udrTwoStrings_PrepReportStrings(0,
      udrTmpTryTmex0.siResult,'TMTouchbyte','16822i');
//Params: group code, error code from TMEX, what routine, where in code.
   PostTwoStrings(kP2both,udrTwoStrings_tmp);
   boErrSeen:=true;//Tell later blocks "don't bother"
   end//no ; here
 else begin
   bChecksumSent:=udrTmpTryTmex0.siResult;
   //HMM... is it an 8bit checksum, or 16? IF 16 THREE THINGS NEED FIXING...
   //in udrTmpTryTmex0 siResult should not be stripped down to LS 8 bits,
   //and in read of first two bytes, the value returnen needs to be
   //stripped down to LS 8 bits before being stored in bTtureHi and bTtureLo
   end;//of else of "if boFail..."
end;//boErrSeen=false

//See if bChecksumSent was what it ought to be.(We'll need to re-write
//above slightly, either to calculate checksum as we
//go along, or to have the 8 bytes available to plug
//into the algorithm.)
if boErrSeen=false then begin
if bChecksumSent<>bCalcChecksum(b7,b6,b5,b4,b3,b2,b1,b0) then begin
    udrTwoStrings_Tmp:=udrTwoStrings_CodedTime(now);
    udrTwoStrings_tmp.sPass0:=udrTwoStrings_Tmp.sPass0+'- code loc16825a: ReadScratchpad checksum failed.';
    udrTwoStrings_tmp.sPass1:=udrTwoStrings_Tmp.sPass1+'- at location 16825a, the Read '+
       'Scratchpad bytes, when subjected to checksum algorithm, returned '+
       'a value that did not match the checksum sent by the 1-Wire chip.';
    PostTwoStrings(kP2both,udrTwoStrings_tmp);
    boErrSeen:=false;
    end//no ; here
  else
    //Nothing
end;//boErrSeen=false
}


result.sWhereErrSeenC:='xx';
result.sWhereErrSeenV:='xxxxxxxxx';
result.siErrSeen:=999;
result.sErrMsgC:=sOutcomeConcise;  //// CLEAN UP... this done... just remove rem
result.sErrMsgV:=sOutcomeVerbose;  //// CLEAN UP... this done... just remove rem
result.boErrSeenL:=boErrSeenL; //// CLEAN UP... this done... just remove rem
end;

function bCalcChecksum(b0,b1,b2,b3,b4,b5,b6,b7:byte):byte;
//CRC calcs.....
//endebted to myself for...
//http://sheepdogguides.com/dst1b.htm
//... which I wrote some time ago. I must
//have stood on the shoulders of others,
//but cannot at this time figure out who.
//Perhaps some sample code in the Delphi
//SDK from Dallas.

//If you send this the bytes of a 1-Wire
//chip, family code LAST (in b7), the
//result should be zero.

//If you send this the bytes resulting
//from a ReadScratchpad command to a
//1-Wire chip in REVERSE order of
//the order they arrive from the
//first EIGHT TMTouchByte($FF)s after
//the TMTouchByte($BE) that started the
//1-Wire chip SENDING the contents of
//its scratchpad, the the function
//will calculate the number which
//should MATCH the NINTH number fetched
//by TMTouchByte($FF). If it matches,
//then none of the 9 bytes were corrupted
//in transmission. In connection with
//this... beware a little "gotcha"...
//The TMEX documentation tell you that
//if a TMTouchByte($FF) returns $FF,
//"it means that the MicroLan is
//shorted". Well... if the MicroLan
//is shorted, TMTouchByte($FF) WILL
//return $FF. BUT!!! SOMETIMES getting
//and $FF simply means that the chip
//you were listening to SENT an $FF.

//If you send this the bytes from a scratch
//pad read, the result should match the
//9th byte returned, the one that follows
//on after the 8 bytes from the scratchpad.

//THE ORDER TO BE DETERMINED AND RECORDED!!

var bAns:byte;
  iaCRC: array [0..7] of byte;//Each should only ever be 0 or 1
  iCRCTmp,c1:integer;
  baBits: array [0..63] of byte;//actually only holding one bit in each element.
        //baBits doing in my prgm what OutBinArray does in original

procedure BitsToArray(bStrt,b0:byte); //SR of function bCalcChecksum
//Starting with element bStrt of baBits, fill 8 elements of bStrt
//   with the bits in b0.
begin
baBits[bStrt-7]:=(b0 and 1);
baBits[bStrt-6]:=(b0 and 2) div 2;
baBits[bStrt-5]:=(b0 and 4) div 4;
baBits[bStrt-4]:=(b0 and 8) div 8;
baBits[bStrt-3]:=(b0 and 16) div 16;
baBits[bStrt-2]:=(b0 and 32) div 32;
baBits[bStrt-1]:=(b0 and 64) div 64;
baBits[bStrt]:=(b0 and 128) div 128;
end;//BitsToArray(bStrt,b0:byte); //SR of function bCalcChecksum

begin//main block of function bCalcChecksum
BitsToArray(63,b0);
BitsToArray(55,b1);
BitsToArray(47,b2);
BitsToArray(39,b3);
BitsToArray(31,b4);
BitsToArray(23,b5);
BitsToArray(15,b6);
BitsToArray(7,b7);

for c1:=0 to 7 do iaCRC[c1]:=0;

for c1:=0 to 63 do begin
   iCRCTmp:=iaCRC[0] XOR baBits[c1];
   iaCRC[0]:=iaCRC[1];
   iaCRC[1]:=iaCRC[2];
   iaCRC[2]:=iaCRC[3] XOR iCRCTmp;
   iaCRC[3]:=iaCRC[4] XOR iCRCTmp;
   iaCRC[4]:=iaCRC[5];
   iaCRC[5]:=iaCRC[6];
   iaCRC[6]:=iaCRC[7];
   iaCRC[7]:=iCRCTmp;
   end;//for...

bAns:=iaCRC[7]*128+iaCRC[6]*64+iaCRC[5]*32+iaCRC[4]*16+
        iaCRC[3]*8+iaCRC[2]*4+iaCRC[1]*2+iaCRC[0];

result:=bAns;
end;//bCalcChecksum

function udrTryTMExendedStartSessionPlusTMSetup(siPortNumL,
       siAdapterTypeL:smallint):TudrTMExtenStrtSessPlusTMSetup;
//This function "wraps up" the calls of TMExtendedStartSession
//  and TMSetup which must be made, usually "once and for all"
//  at the start of any application using TMEX/ 1-Wire/ MicroLan

//If all goes well, it passes back to the calling code:
//  A valid session handle (in .liSessHdl)
//  .boSessionValid set to true.
//  Messages of congratulations, i.e. 'TMExtendedStartSession/TMSetup
//       successfully executed ((time))' (For on screen events log,
//       m/r events log.

//If either call fails, the function returns
//  .boSessionValid set to false.
//  .liSessHdl will hold the error returned by the
//     procedure which returned an error... NB: If it
//     is TMSetup which fails, a smallint value will
//     have been pushed into a longing variable. (This
//     was to avoid the confusion of having two places
//     to look for the error code.)
//  The code for how the attempt failed in .siResultCode
//  Two versions of a report as to what happened, in
//      .sMsgConcise, and sMsgVerbose.

//In record it returns:
//   liSessHdl:longint;
//   //The "message" strings may contain error msgs,
//   //warnings, or reports of success
//   sMsgConcise,sMsgVerbose:string;
//   boSessionValid:boolean;//Not to be confused with
//   //global boSessionValid, which will be filled
//   //from this.
var liSessL:longint;
    siTmpL,siResultCode:smallint;
    sMsgConcise,sMsgVerbose:string;
    boSessionValid:boolean;

begin
  siResultCode:=2;
  sMsgConcise:='- App started ok. (loc16825b)'; //concise msg
  sMsgVerbose:='- Application started properly. (loc16825c)';//verbose msg


  boSessionValid:=true;
  liSessL:=TMExtendedStartSession(siPortNumL,
     siAdapterTypeL,nil);
  //Last parameter slightly problematic. This "solution"
  //  rec'd by forum poster. Alternative:
  //  TMExtendedStartSession(siPortNum,
  //    siAdapterType,myPointer);//This was my "solution"...
  //    may have flaws, may not. Runs okay, doesn't fall over instantly.
  //    Requires a declaration...
  //       myPointer:pointer;//Almost a kludge!


  if liSessL<=0 then begin//<=0 is a fail
     //REVISE: This won't fail "once in a while. If it fails, there
     //   is no point in proceeding.
     sMsgConcise:='consie ver of... Call of TMExtendedStartSession failed. '+
       'Change Adapter/ Port/ Chip ID setting. Close. Restart.';
     sMsgVerbose:='verbose ver of...Call of TMExtendedStartSession failed. '+
       'Change Adapter/ Port/ Chip ID setting. Close. Restart.';
     boSessionValid:=false;
     end;

//Do the required-once TMSetup
if boSessionValid then begin
     siTmpL:=TMSetup(liSessL);
     if siTmpL<>1 then begin//<>1 is a fail
        //This won't fail "once in a while. If it fails, there
        //   is no point in proceeding.
        liSessL:=siTmpL;//move the error code to the place
          //the calling program will look for it.
        //qDO: INCLUDE HUMAN FRIENDLY TEXT OF ERROR CODES IN
        //MESSAGES... at least the VERBOSE ONE.
        sMsgConcise:='consie ver of... Call of TMSetup failed. '+
                     'Shutting down.';
        sMsgVerbose:='verbose ver of.... Call of TMSetup failed. '+
                     'Shutting down.';
        boSessionValid:=false;
        end;//.. if siTmpL<>1...
     end;//if boSessionValid...

  result.liSessHdl:=liSessL;
  result.sMsgConcise:=sMsgConcise;
  result.sMsgVerbose:=sMsgVerbose;
  result.boSessionValid:=boSessionValid;
end; //udrTryTMExendedStartSessionPlusTMSetup

function sVerTmex_Support:string;
begin
result:=kTmexSupportUnitVers;
end;

procedure FillSiaRom(bWhichChip:byte);
var bCount:byte;
//NB: "Family code" goes in siNumbersForTMRom[0], and rest fill with
//  the parts of the ID code from family code end to other end.
//I.e. if the family code were 28, and the chip ID were...
//  1122334455667728, then  siNumbersForTMRom[0],[1],[2], etc would be..
//  28, 77, 66, 55, 44, 33... etc, with 11 going in siNumbersForTMRom[7]

//What subroutine does...
//    siaRom[0]:=strtoint('$'+copy(sChipID[bTmp],15,2));
//    siaRom[1]:=strtoint('$'+copy(sChipID[bTmp],13,2));
//    ...
//    siaRom[7]:=strtoint('$'+copy(sChipID[bTmp],1,2));

begin
for bCount:=0 to 7 do begin
   siaROM[7-bCount]:=strtoint('$'+
            copy(ldn032f1.sChipID[bWhichChip],(bCount*2)+1,2));
   //showmessage(inttostr(strtoint('$'+
   //copy(ldn032f1.sChipID[bWhichChip],(bCount*2)+
   //  1,2))));// <<for testing. (Add "Dialogs" to units Uses clause to use
   //showmessage.
   end;//for
end;//FillSiaRom

function udrTryTMTouchByteRead:TudrTryTmex0;
//This function tries to do a TMTouchByte READ-FROM-MICROLAN
//(TMTouchByte with 2nd param = $FF. TMTouchByte can
//    also be used to WRITE a byte... but not via this SR!

//Returns result, incl messages about any error that arises.

//N.B: THE GLOBAL VARIABLE "liSessHdl" is accessed directly from
//within the subroutine. BAD PRACTICE, but I had my reasons,
//and the "error" is easily removed, if someone wants to be
//fussy. (Just add another parameter to the calling.)

//Yes: Second param is a smallint, even though it is for a byte.
//This to "be faithful" to what it shows in the TMEX API Help.

var siTmpL:smallint;
  boTmpL:boolean;//boFail will be filled from this
begin
boTmpL:=true;//init saying "call failed"
siTmpL:=TMTouchByte(ldn032f1.liSessHdl,$FF);
if siTmpL>=0 then boTmpL:=false;//do this if call SUCCESSFUL
//VERY DUBIOUS... SHOULD THE NEXT BE REMMED OUT???
//TMEX API help tells us that a return of $FF means MicroLan shorted...
//... but what if the DATA is $FF? How is that to be sent/ distinguished
//... from a "LAN SHORTED" condition??
//if siTmpL=255 then boTmpL:=true;//oops... NOT successful, after all.
if boTmpL=false then siTmpL:=siTmpL and $FF;
result.boFail:=boTmpL;
result.siResult:=siTmpL;//Either holds error code or LS 8 bits of
  //word read from chip.

(* OLD STUFF SCRAPS.....
function ReportErr(bCallType:byte;siErr:smallint;sRoutine,sLoc:string):string;
//bCallType: A TKB allocated code... see sErrCodeToStr
//siErr: The error code returned from a TMEX call
//sRoutine: The name of the routine that returned the error, e.g. TMTouchByte
//   (What this can be restricted by bCallType, but several routines can
//    share one bCallType)
//sLoc: A unique string to ID where the call was in the code, so de-bugging
//   can be done.

//Inserts a verbose string into a memo.
//Returns a concise string which typically would be passed to a log file.
begin
ldn032f1.meMsgs.lines.insert(0,'Err seen at ((time)) when '+sRoutine+
   ' called: '+sErrCodeToStr(bCallType,siErr)+
   '. Prgm was at "'+sLoc+'"');
result:=sCodedTime(now)+' In code at:'+sLoc+' saw err '+inttostr(siErr)+
   ' on call '+sRoutine;
end;//ReportErr
*)
end;//udrTryTMTouchByte

function sErrCodeToStr(bCallType:byte;siErrCode:smallint):string;
//Turn a code for CallType and a TMEX error code into a string.

//The CallType parameter has values defined by what you find in this
//  subroutine. It allows multiple TMEX calls to share bits of this
//  code... only such calls as have identical Error Codes. The numbers
//  assigned to such "call groups" is arbitrary, and chosen by TKB
//The ErrCode is the one returned by the TMEX routine.

//Strings returned should be sentences, but have no terminal full stop.
var sResult:string;
begin
case bCallType of
0:begin//Use this for TMTouchByte
  //... possibly any that use 'TMEX Hardware Specific Error Return Codes'
   case siErrCode of
   255: sResult:='MicroLan shorted at time of reading';
    -1: sResult:='Specified MicroLan has not been initialized with a '+
          'call to the TMSetup function';
    -2: sResult:='Specified MicroLan nonexistent';
    -3: sResult:='Function not supported';
   -12: sResult:='Failure to communicate with hardware adapter';
   -13: sResult:='An unsolicited event occurred on the 1-Wire';
  -200: sResult:='Session not valid (not applicable in DOS TMEX)';
  -201: sResult:='Hardware_Specific driver not found and is required';

   else sResult:='Unexpected code passed to sErrCodeToStr for bCallType 0';
   end;//of case siErrCode
  end;//handle case '0'

99:begin
  end;//even LAST "then" before "else" SHOULD have ; in Case structure
else sResult:='SeeSErrCodeToStr:ACaseNotProvidedFor.ItIsCaseOf:'+
   inttostr(bCallType);
end;//case
result:=sResult;
end;//sErrCodeToStr

//Remove?...
function udrTmp_TestTryUDR:TudrTmp_Test;
begin
 result.sFrmTest:='xx';
end;

//Remove?...
function TB_TmpTrial:string;
begin
result:='trial of a put-in-sub-unit touchbyte';
end;

end.

